import 'package:developer_support/developer_support.dart';

class ResultData {
  bool isSuccess;
  String? message;
  dynamic data;

  ResultData({
    this.isSuccess = true,
    this.message,
    this.data,
  });

  factory ResultData.success({dynamic data}) {
    return ResultData(
      isSuccess: true,
      message: "Success",
      data: data,
    );
  }

  factory ResultData.error({required String? errorMessage, dynamic data}) {
    "errorMessage:.. $errorMessage".Log();
    return ResultData(
      isSuccess: false,
      message: errorMessage ?? "error message: null.",
      data: data,
    );
  }

  factory ResultData.fromJson(Map<String, dynamic> json) {
    return ResultData(
      isSuccess: json["isSuccess"].toLowerCase() == 'true',
      message: json["message"],
      data: json["data"],
    );
  }

  Map<String, dynamic> toJson() {
    return {
      "isSuccess": this.isSuccess,
      "message": this.message,
      "data": this.data,
    };
  }
}
