import 'dart:math';

import 'package:path/path.dart' as path;
import 'package:stack_trace/stack_trace.dart';

var isEnableTimber = true;

class Timber {
  var logs = <String>[];
  var symbolRows = ["="];
  var symbolDivider = "-";
  var random = Random();
  late var symbolRow = symbolRows[random.nextInt(symbolRows.length)];
  var symbolCol = "╎";
  var symbolCorner = "□";
  var maxLengthLine = 120;
  late var maxLengthSpace = maxLengthLine + 5;
  var isEnableTimber = false;

  Timber({
    this.isEnableTimber = false,
  });

  divider({String? tag}) {
    if (isEnableTimber) {
      var divider = symbolDivider * (maxLengthSpace - (tag?.length ?? 0));
      logs.add("${tag ?? ""}" + divider);
    }
  }

  add(String line) {
    if (isEnableTimber) {
      logs.add(line);
    }
  }

  addAll(List<String> lines) {
    if (isEnableTimber) {
      lines.forEach((element) {
        logs.add(element);
      });
    }
  }

  clear() {
    if (isEnableTimber) {
      logs.clear();
    }
  }

  write({String tag = ""}) {
    if (isEnableTimber) {
      _dividerTopPrint(tag);
      _contentPrint();
      _dividerPrint();
    }
  }

  _contentPrint() {
    for (var element in logs) {
      if (element.length > maxLengthLine) {
        _rowsPrint(element);
      } else {
        _rowPrint(element);
      }
    }
  }

  _dividerTopPrint(String tag) {
    var trace = "${tag}:" + _trace(index: 2);
    var divider = symbolRow * (maxLengthSpace - 2 - trace.length - 2);
    print(symbolCorner + "[${trace}]" + divider + symbolCorner);
  }

  _dividerPrint({String? symbolRow}) {
    var divider = (symbolRow ?? this.symbolRow) * (maxLengthSpace - 2);
    print(symbolCorner + divider + symbolCorner);
  }

  _rowPrint(String content) {
    var _content = content.trimLeft();
    var line = symbolCol + " " + _content + _space(_content.length) + symbolCol;
    print(line);
  }

  _space(int lengthCurrent) {
    return " " * (maxLengthSpace - lengthCurrent - 3);
  }

  _rowsPrint(String content) {
    var rows = _split(content);
    rows.forEach((element) {
      _rowPrint(element);
    });
  }

  String _trace({int index = 1}) {
    Frame trace = Trace.current(1).terse.frames[index];
    var library = path.prettyUri(trace.uri);
    var line = trace.line;
    var column = trace.column;
    var url = '$library $line:$column ⇙';
    return url;
  }

  List<String> _split(String content) {
    var length = content.length ~/ maxLengthLine;
    var list = <String>[];
    for (var index = 0; index < length; index++) {
      var start = index * maxLengthLine;
      var end = (index + 1) * maxLengthLine;
      if (end > content.length) {
        end = content.length;
      }
      var line = content.substring(start, end);
      list.add(line);
    }
    return list;
  }
}
